'Text Screen Clearing SUBs - Created by, and only by:  Ben Hendel-Doying

'Decalre SUBs

DECLARE SUB BlockOut50 ()
DECLARE SUB BlockOut25 ()
DECLARE SUB Pause ()

'The two SUBs here are used to clear either WIDTH 80, 25 screens (BlockOut25)
'or WIDTH 80, 50 screens (BlockOut50).  The effects would be better described
'as Dissolve.

'----------------------------------------------------------------------------

'BlockOut25, clears screen at WIDTH 80, 25

WIDTH 80, 25        'Set screen

RANDOMIZE TIMER     'Randomize
VIEW PRINT          'Make sure we can PRINT on the 25th line w/o scrolling

COLOR 0, 7

FOR y = 1 TO 25
  PRINT SPACE$(80); 'Fill screen w/ grey
NEXT

COLOR 7, 0

LOCATE 1, 1: PRINT "Press a key to clear..."
Pause               'Wait for key press

BlockOut25          'Clear Screen

'----------------------------------------------------------------------------

'BlockOut50, clears screen at WIDTH 80, 50

WIDTH 80, 50        'Set screen

RANDOMIZE TIMER     'Randomize
VIEW PRINT          'Make sure we can PRINT on 50th line w/o scrolling

COLOR 0, 7

FOR y = 1 TO 50
  PRINT SPACE$(80); 'Fill screen w/ grey
NEXT

COLOR 7, 0

LOCATE 1, 1: PRINT "Press a key to clear..."
Pause               'Wait for key press

BlockOut50          'Clear Screen

'----------------------------------------------------------------------------

SUB BlockOut25
  DIM x(1 TO 2000) AS INTEGER
  DIM y AS INTEGER
  DIM z AS INTEGER

  FOR y = 1 TO 2000
    x(y) = y
  NEXT

  FOR y = 1 TO 2000
    SWAP x(y), x(INT(RND * 2000) + 1)
  NEXT

  FOR y = 1 TO 2000
    z = 1
    DO WHILE x(y) > 80
      x(y) = x(y) - 80
      z = z + 1
    LOOP
    LOCATE z, x(y): PRINT " ";
  NEXT
END SUB

SUB BlockOut50
  DIM x(1 TO 4000) AS INTEGER
  DIM y AS INTEGER
  DIM z AS INTEGER

  FOR y = 1 TO 4000
    x(y) = y
  NEXT

  FOR y = 1 TO 4000
    SWAP x(y), x(INT(RND * 2000) + 1)
  NEXT

  FOR y = 1 TO 4000
    z = 1
    DO WHILE x(y) > 80
      x(y) = x(y) - 80
      z = z + 1
    LOOP
    LOCATE z, x(y): PRINT " ";
  NEXT
END SUB

SUB Pause
  DO: LOOP UNTIL INKEY$ <> ""
END SUB

